/*! \mainpage Task Description
 *
 * Create a namespace named __my__ and inside this namespace implement the functions described below.
 * Create __definitions__ of the functions you implement in solutions.hpp file, and the __implementations__ in solution.cpp file.
 *
 * Unless stated otherwise, all the functions are expected to return nothing.
 *
 * __IMPORTANT!__ Before submitting your solution to git, please ensure that all the `#define` macros in solution.hpp file are uncommented,
 * and that your solution produces to compilation or linker errors messages during the buid process.
 *
 *
 * 1. A function named `set10` which sets the value of an integer, passed to the function as argument, to 10.
 *    Uncomment `#define SET10_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 2. A function named `set20` which sets the value of the integer, passed to the function as argument by address, to 20.
 *    Uncomment `#define SET20_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 3. A function named `set50` which sets the value of the integer, passed to the function as a pointer to a pointer to an integer, to 50.
 *    Uncomment `#define SET50_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 4. A function named `setHelloWorld` which sets the value of an `std::string`, passed to the function as argument, to "Hello, World!".
 *    Uncomment `#define SET_HELLOWORLD_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 5. A function named `setBadBeef` which sets the value of the pointer to an `int`, passed to the function as argument by address, to 0xBADBEEF.
 *    Uncomment `#define SET_BADBEEF_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 6. A function named `setBadCode` which sets the value of the pointer to an `int`, passed to the function as argument, to 0xBADC0DE.
 *    Uncomment `#define SET_BADCODE_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 7. A function named `callFunction1`, which takes a single argument - a pointer to a function that takes no arguments and returns an integer,
 *    calls this function, and returns whatever result the called function provides.
 *    Uncomment `#define CALL_FUNCTION1_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 8. A function named `callFunction2`, which takes two arguments - the first argument is a pointer to a function taking a pointer of type `void*` as argument
 *    and returning a value of type `bool`, and the second argument is a pointer of type void*, which is an argument to the function being called.
 *    `callFunction2` calls the function (the first argument of `callFunction2`) with its argument (the second argument of `callFunction2`) and
 *    returns whatever value the called function returns.
 *    Uncomment `#define CALL_FUNCTION2_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 9. A function named `callFunction3`, which takes 5 arguments. The first argument is a pointer to a function that returns a value of type `int` and
 *    takes two arguments of type `int`. The remaining 4 arguments of `callFunction3` are values of type `int`. `callFunction3` calls the function,
 *    provided in the first argument twice, the first time supplying it arguments given in arguments 2 and 3, the second time with arguments 4 and 5, then
 *    returns the sum of the return values of both calls.
 *    Uncomment `#define CALL_FUNCTION3_IMPLEMENTED` line in solution.hpp file to test your implementation.
 * 10. A function named `callFunction4`, which takes a single argument - an rvalue reference to a function that takes no arguments and returns a value of type `int`,
 *     calls the given function and returns whatever value the called function returns.
 *     Uncomment `#define CALL_FUNCTION4_IMPLEMENTED` line in solution.hpp file to test your implementation.
 */

#include "solution.hpp"

